#!/bin/bash
#
# Copyright 2013 by guy maurel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# 8 november 2013
#
numberOfParameter=$#
if [ $numberOfParameter -eq 0 ] ;
then
  #echo "Parameter is missing"
  WHERE="./"
else
  WHERE=${1}
fi
nameOfTheScript=${0}
#
DIR="/home/guy-kde/Software/coding-style-check"
#DIR="/usr/local/coding-style-check"
if [ -d ${WHERE} ] ;
then
  # Is a directory
  if [ -r ${WHERE} ] ;
  then
    if [ -a ".no_coding_style" ] 
    then
      #echo "Datei .no_coding_file gefunden"
      exit
    fi
    if [ ${WHERE} != "build" ] 
    then
      cd ${WHERE}
      liste=`ls -1A`
      for file_1 in ${liste}
      do
        ${nameOfTheScript} ${file_1}
      done
      cd ..
    fi
  fi
else
  # Is a file
  do_it="no"
  base_1=`basename ${WHERE} .h`
  if [ ${base_1} != ${WHERE} ] ;
  then
    do_it="yes"
  fi
  base_1=`basename ${WHERE} .cpp`
  if [ ${base_1} != ${WHERE} ] ;
  then
    do_it="yes"
  fi
  if [ ${do_it} == "yes" ] ;
  then
    gawk -f ${DIR}/Tabs-change.awk < ${WHERE} > ${WHERE}.tabs
    diff ${WHERE} ${WHERE}.tabs >/dev/null 2>&1
    how_different=$?
    if [ $how_different == "1" ] ;
    then
      echo "change the file "`pwd`/${WHERE}
      mv ${WHERE}.tabs ${WHERE}
    else
      rm ${WHERE}.tabs
    fi
  fi
fi
